//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZCTreeManagerParent_h
#define PAPZCTreeManagerParent_h

#include "mozilla/layers/PAPZCTreeManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "InputData.h"
#include "Units.h"
#include "ipc/nsGUIEventIPC.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/MouseEvents.h"
#include "mozilla/dom/TabMessageUtils.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"
#include "mozilla/layers/LayersMessageUtils.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class KeyboardMap;
} // namespace layers
} // namespace mozilla

namespace mozilla {
class WidgetInputEvent;
} // namespace mozilla

namespace mozilla {
class WidgetMouseEventBase;
} // namespace mozilla

namespace mozilla {
class WidgetTouchEvent;
} // namespace mozilla

namespace mozilla {
class WidgetWheelEvent;
} // namespace mozilla

namespace mozilla {
class InputData;
} // namespace mozilla

namespace mozilla {
class MultiTouchInput;
} // namespace mozilla

namespace mozilla {
class MouseInput;
} // namespace mozilla

namespace mozilla {
class PanGestureInput;
} // namespace mozilla

namespace mozilla {
class PinchGestureInput;
} // namespace mozilla

namespace mozilla {
class TapGestureInput;
} // namespace mozilla

namespace mozilla {
class ScrollWheelInput;
} // namespace mozilla

namespace mozilla {
class KeyboardInput;
} // namespace mozilla

namespace mozilla {
namespace layers {


class PAPZCTreeManagerParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::layers::PCompositorBridgeParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::InputData InputData;
    typedef mozilla::KeyboardInput KeyboardInput;
    typedef mozilla::layers::KeyboardMap KeyboardMap;
    typedef mozilla::LayoutDevicePoint LayoutDevicePoint;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef mozilla::MouseInput MouseInput;
    typedef mozilla::MultiTouchInput MultiTouchInput;
    typedef mozilla::PanGestureInput PanGestureInput;
    typedef mozilla::PinchGestureInput PinchGestureInput;
    typedef mozilla::PinchGestureInput::PinchGestureType PinchGestureType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::WidgetMouseEvent::Reason Reason;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ScrollWheelInput ScrollWheelInput;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::TapGestureInput TapGestureInput;
    typedef mozilla::layers::GeckoContentController::TapType TapType;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::layers::FrameMetrics::ViewID ViewID;
    typedef mozilla::WidgetInputEvent WidgetInputEvent;
    typedef mozilla::WidgetMouseEventBase WidgetMouseEventBase;
    typedef mozilla::WidgetTouchEvent WidgetTouchEvent;
    typedef mozilla::WidgetWheelEvent WidgetWheelEvent;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;

    typedef PAPZCTreeManager::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags) = 0;
    virtual mozilla::ipc::IPCResult
    RecvContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& Targets) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetKeyboardMap(const KeyboardMap& aKeyboardMap) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetDPI(const float& aDpiValue) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aValues) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartAutoscroll(
            const ScrollableLayerGuid& aGuid,
            const ScreenPoint& aAnchorLocation) = 0;
    virtual mozilla::ipc::IPCResult
    RecvStopAutoscroll(const ScrollableLayerGuid& aGuid) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetLongTapEnabled(const bool& aTapGestureEnabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvProcessTouchVelocity(
            const uint32_t& aTimestampMs,
            const float& aSpeedY) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceiveMultiTouchInputEvent(
            const MultiTouchInput& aEvent,
            nsEventStatus* aOutStatus,
            MultiTouchInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceiveMouseInputEvent(
            const MouseInput& aEvent,
            nsEventStatus* aOutStatus,
            MouseInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivePanGestureInputEvent(
            const PanGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PanGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceivePinchGestureInputEvent(
            const PinchGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PinchGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceiveTapGestureInputEvent(
            const TapGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            TapGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceiveScrollWheelInputEvent(
            const ScrollWheelInput& aEvent,
            nsEventStatus* aOutStatus,
            ScrollWheelInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvReceiveKeyboardInputEvent(
            const KeyboardInput& aEvent,
            nsEventStatus* aOutStatus,
            KeyboardInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateWheelTransaction(
            const LayoutDeviceIntPoint& aRefPoint,
            const EventMessage& aEventMessage) = 0;
    virtual mozilla::ipc::IPCResult
    RecvProcessUnhandledEvent(
            const LayoutDeviceIntPoint& aRefPoint,
            LayoutDeviceIntPoint* aOutRefPoint,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutFocusSequenceNumber) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PAPZCTreeManagerParent();

    virtual ~PAPZCTreeManagerParent();

    PCompositorBridgeParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId);

    MOZ_MUST_USE bool
    SendNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers);

    MOZ_MUST_USE bool
    SendCancelAutoscroll(const ViewID& aScrollId);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::layers::PAPZCTreeManagerParent*>
{
    typedef mozilla::layers::PAPZCTreeManagerParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZCTreeManagerParent :
    public PAPZCTreeManagerParent
{
    mozilla::ipc::IPCResult
    RecvZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags) override;

    mozilla::ipc::IPCResult
    RecvContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault) override;

    mozilla::ipc::IPCResult
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& Targets) override;

    mozilla::ipc::IPCResult
    RecvUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints) override;

    mozilla::ipc::IPCResult
    RecvSetKeyboardMap(const KeyboardMap& aKeyboardMap) override;

    mozilla::ipc::IPCResult
    RecvSetDPI(const float& aDpiValue) override;

    mozilla::ipc::IPCResult
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aValues) override;

    mozilla::ipc::IPCResult
    RecvStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics) override;

    mozilla::ipc::IPCResult
    RecvStartAutoscroll(
            const ScrollableLayerGuid& aGuid,
            const ScreenPoint& aAnchorLocation) override;

    mozilla::ipc::IPCResult
    RecvStopAutoscroll(const ScrollableLayerGuid& aGuid) override;

    mozilla::ipc::IPCResult
    RecvSetLongTapEnabled(const bool& aTapGestureEnabled) override;

    mozilla::ipc::IPCResult
    RecvProcessTouchVelocity(
            const uint32_t& aTimestampMs,
            const float& aSpeedY) override;

    mozilla::ipc::IPCResult
    RecvReceiveMultiTouchInputEvent(
            const MultiTouchInput& aEvent,
            nsEventStatus* aOutStatus,
            MultiTouchInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceiveMouseInputEvent(
            const MouseInput& aEvent,
            nsEventStatus* aOutStatus,
            MouseInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceivePanGestureInputEvent(
            const PanGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PanGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceivePinchGestureInputEvent(
            const PinchGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PinchGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceiveTapGestureInputEvent(
            const TapGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            TapGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceiveScrollWheelInputEvent(
            const ScrollWheelInput& aEvent,
            nsEventStatus* aOutStatus,
            ScrollWheelInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvReceiveKeyboardInputEvent(
            const KeyboardInput& aEvent,
            nsEventStatus* aOutStatus,
            KeyboardInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) override;

    mozilla::ipc::IPCResult
    RecvUpdateWheelTransaction(
            const LayoutDeviceIntPoint& aRefPoint,
            const EventMessage& aEventMessage) override;

    mozilla::ipc::IPCResult
    RecvProcessUnhandledEvent(
            const LayoutDeviceIntPoint& aRefPoint,
            LayoutDeviceIntPoint* aOutRefPoint,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutFocusSequenceNumber) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT APZCTreeManagerParent();
    virtual ~APZCTreeManagerParent();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvZoomToRect(
        const ScrollableLayerGuid& aGuid,
        const CSSRect& aRect,
        const uint32_t& Flags)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvContentReceivedInputBlock(
        const uint64_t& aInputBlockId,
        const bool& PreventDefault)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvSetTargetAPZC(
        const uint64_t& aInputBlockId,
        nsTArray<ScrollableLayerGuid>&& Targets)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvUpdateZoomConstraints(
        const ScrollableLayerGuid& aGuid,
        const MaybeZoomConstraints& aConstraints)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvSetKeyboardMap(const KeyboardMap& aKeyboardMap)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvSetDPI(const float& aDpiValue)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvSetAllowedTouchBehavior(
        const uint64_t& aInputBlockId,
        nsTArray<TouchBehaviorFlags>&& aValues)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvStartScrollbarDrag(
        const ScrollableLayerGuid& aGuid,
        const AsyncDragMetrics& aDragMetrics)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvStartAutoscroll(
        const ScrollableLayerGuid& aGuid,
        const ScreenPoint& aAnchorLocation)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvStopAutoscroll(const ScrollableLayerGuid& aGuid)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvSetLongTapEnabled(const bool& aTapGestureEnabled)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvProcessTouchVelocity(
        const uint32_t& aTimestampMs,
        const float& aSpeedY)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceiveMultiTouchInputEvent(
        const MultiTouchInput& aEvent,
        nsEventStatus* aOutStatus,
        MultiTouchInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceiveMouseInputEvent(
        const MouseInput& aEvent,
        nsEventStatus* aOutStatus,
        MouseInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceivePanGestureInputEvent(
        const PanGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        PanGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceivePinchGestureInputEvent(
        const PinchGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        PinchGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceiveTapGestureInputEvent(
        const TapGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        TapGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceiveScrollWheelInputEvent(
        const ScrollWheelInput& aEvent,
        nsEventStatus* aOutStatus,
        ScrollWheelInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvReceiveKeyboardInputEvent(
        const KeyboardInput& aEvent,
        nsEventStatus* aOutStatus,
        KeyboardInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvUpdateWheelTransaction(
        const LayoutDeviceIntPoint& aRefPoint,
        const EventMessage& aEventMessage)
{
}

mozilla::ipc::IPCResult
APZCTreeManagerParent::RecvProcessUnhandledEvent(
        const LayoutDeviceIntPoint& aRefPoint,
        LayoutDeviceIntPoint* aOutRefPoint,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutFocusSequenceNumber)
{
}

void
APZCTreeManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT APZCTreeManagerParent::APZCTreeManagerParent()
{
    MOZ_COUNT_CTOR(APZCTreeManagerParent);
}

MOZ_IMPLICIT APZCTreeManagerParent::~APZCTreeManagerParent()
{
    MOZ_COUNT_DTOR(APZCTreeManagerParent);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZCTreeManagerParent_h
